# -------------------------------------------------------------------------
# (c) 2017, Johann Oberdorfer - Engineering Support | CAD | Software
#     johann.oberdorfer [at] gmail.com
#     www.johann-oberdorfer.eu
# -------------------------------------------------------------------------
# This source file is distributed under the BSD license.
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#   See the BSD License for more details.
# -------------------------------------------------------------------------
# -------------------------------------------------------------------------

set dir [file dirname [info script]]

# where to find contributed library packages
lappend auto_path [file join $dir "."]
lappend auto_path [file join $dir "../../../../00-lib"]
lappend auto_path [file join $dir "../../../../00-lib3"]
lappend auto_path [file join $dir "../../../../00-libbin"]

package require Tk
package require -exact Tkhtml 3.0

package require infowindow 1.1
package require Markdown
package require fileutil
package require html3widget


# here we go:


catch {
	console show
	console eval {wm protocol . WM_DELETE_WINDOW {exit 0}}
}


set w [toplevel .infowin_test]

wm withdraw .
wm geometry $w "400x600+200+200"
wm protocol $w WM_DELETE_WINDOW {exit 0}

# message can be written in markdown syntax and 'll be
# converted at runtime to valid html code,
# which is finally passed over to the html3widget ...

set msg ""

append msg "\n<center>"

append msg \
"
# Application XXX: <span class=\"label label-success\">Ver X.XX </span>

Author: J.Oberdorfer
<br>Homepage: <http://johann-oberdorfer.eu>

This program is made with love and distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

<strong>Tcl/Tk Version:</strong> $::tk_version

The following packages are currently in used:

"

# <span class=\"label label-success\"> </span>

set cnt 0
foreach pname [lsort -dictionary [package names]] {
	
	if {[catch {package present $pname} ver] == 0} {
		# puts "$pname : $ver"
	
		if {$cnt > 0} {append msg " / "}
		append msg "${pname} : `${ver}`"
		incr cnt
	}
}


append msg "\n<center>"

# -customimage by default is "no", but if specified, superseeds both options:
# -image and -imagetxt

::infowindow::infowindow \
			-wparent $w \
			-message $msg \
			-customimage "yes" \
			-geometry "800x500"

set usr [::infowindow::infowindow \
			-wparent $w \
			-message $msg \
			-image "info" \
			-imagetxt "Information:" \
			-type "okcancel"]

puts $usr	

